// gates.h

#pragma once
#include "circuit.h"

#if defined(_EXTRA)

class eDevice: public eObj
{
public:
	vector<eNode> nodes;
	int cycles;

	eDevice &Create(eNode &A, eNode &B, eNode &Out);
	eDevice &Create(eNode &A, eNode &B, eNode &C, eNode &Out);
	eDevice &Create(eNode *inp, int n, eNode &Out);
	int eDevice::aoi(int in, int out);


	void add(eNode &node) { nodes.AddTail(&node); }
	void add(eDevice &device) { devices.AddTail(&device); }
	void reset();
	void reset_nodes();

	virtual int eval();
//	virtual int run();
};
#endif


class Inverter: public eDevice
{
public:
	Inverter(): eDevice(2) { }
	int getNodeCount() const { return 2; }
	string getType() const { return "inverter"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

class Buffer: public eDevice
{
public:
	Buffer(): eDevice(2) { }
	int getNodeCount() const { return 2; }
	string getType() const { return "buffer"; }
	static const string code;
	string codeString() const { return code; }
	//int eval();
};


class And: public eDevice
{
public:
	And(): eDevice(3) { }
	int getNodeCount() const { return 3; }
	string getType() const { return "and"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

class Nand: public eDevice
{
public:
	Nand(): eDevice(3) { }
	int getNodeCount() const { return 3; }
	string getType() const { return "nand"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

class Or: public eDevice
{
public:
	Or(): eDevice(3) { }
	int getNodeCount() const { return 3; }
	string getType() const { return "or"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

class Nor: public eDevice
{
public:
	Nor(): eDevice(3) { }
	int getNodeCount() const { return 3; }
	string getType() const { return "nor"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

class Xor: public eDevice
{
public:
	Xor(): eDevice(3) { }
	int getNodeCount() const { return 3; }
	string getType() const { return "xor"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

class Xnor: public eDevice
{
public:
	Xnor(): eDevice(3) { }
	int getNodeCount() const { return 3; }
	string getType() const { return "xnor"; }
	static const string code;
	string codeString() const { return code; }
	int eval(eNode *nodes[]);
};

