/* \file strtoken.cpp
*
*/
#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>

//! skips whitespace and returns next token (or null pointer)
/*!
 * \param str is input c-string (modified to point to character after
 * delimiter
 * \param delimiter marks the end of a token (usually a blank)
 * \retval c-string pointing to start of delimiter.
 * The delimiter character in the input string is replaced by a null
 * character.
 */

char *strtoken(char* &str, char delimiter)
{
	//char *str = *inp;
	if (str==0) return 0;
	while (*str == ' ') str++; // skip whitespace
	//*inp = str;
	if (*str==0) return 0;
	char *token = str;
	while (*str && *str!=delimiter) str++;
	if (*str) *str++ = 0; // substitute null for delimiter to terminate token
	//*inp = str;
	return token;
}

